package com.example.mqttdemo;

import org.eclipse.paho.client.mqttv3.*;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.util.UUID;

/**
 * @Description: 平台mqtt演示
 * @Version: 1.0.0
 */

public class SubscribeDemo {
    public static void main(String[] args) {
        String broker = "tcp://rtd.mqtt.0531yun.com:1883";
        /**
         * 主题规则  rtd/ + 平台groupId
         * 需要平台用户具有待订阅groupId的查看权限
         */
        String topic = "rtd/平台groupId";
        String username = "平台用户名";
        String password = "平台密码";
        String clientId = UUID.randomUUID().toString();

        int qos = 0;

        try {
            MqttClient client = new MqttClient(broker, clientId, new MemoryPersistence());
            // 连接参数
            MqttConnectOptions options = new MqttConnectOptions();
            options.setUserName(username);
            options.setPassword(password.toCharArray());
            //设置连接超时时间
            options.setConnectionTimeout(60);
            //设置心跳间隔
            options.setKeepAliveInterval(60);
            // 设置回调
            client.setCallback(new MqttCallback() {

                @Override
                public void connectionLost(Throwable cause) {
                    System.out.println("connectionLost: " + cause.getMessage());
                }

                @Override
                public void messageArrived(String topic, MqttMessage message) {
                    System.out.println("topic: " + topic);
                    System.out.println("Qos: " + message.getQos());
                    System.out.println("message content: " + new String(message.getPayload()));
                }

                @Override
                public void deliveryComplete(IMqttDeliveryToken token) {
                    System.out.println("deliveryComplete---------" + token.isComplete());
                }

            });
            client.connect(options);
            client.subscribe(topic, qos);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}